/* ::abs16.b::
 * This little example declares a two byte array to create a
 *	16-bit word. It fills this word from RTCC (low byte = high-byte). 
 *	It then calls the function abs16() if the word is negative.  
 */

const	H=0, L=1
const	RTCC = 1, STATUS = 3, CARRY = 0, MSB = 7

int8	value[2]@0x0c
// Allocate value[] at location 0x0c. Normally done via VARSTART.

loop {	// Do the following in an infinite loop
	value[H]=value[L]=*RTCC
	if(value[H] ? MSB) {  // check sign of value[]
		abs16()			  // and call ABS16 if negative
	}
}

abs16(){ // abs(value) ==> value
	// negate value[] by complementing and incrementing
	complement(value[L]); complement(value[H])
	value[L] += 1 //inc(value[L]) will not work since it does not affect CARRY
	(*STATUS ? CARRY) inc(value[H])
}
