/* ::add16.b::
 * This example shows how to add two 16 bit words using an inline function
 * The special function register assignments are  according to the PIC16C71
 * memory organization.
 */

const	H=0, L=1,
		RTCC = 1, STATUS = 3, CARRY = 0, MSB = 7

int8	value1H,value1L,value2H,value2L

/* This inline function adds two 16 bit words acc1 and acc2 
   and saves the sum in acc2. Thus, acc1 + acc2 ==> acc2.	*/
inline 	add16 (acc1H,acc1L,acc2H,acc2L){
	*acc2L += *acc1L	    // add lower byte 
	(*STATUS ? CARRY) ++*acc2H  //if CARRY increment higher byte of acc2 
	*acc2H += *acc1H 	    // add higher byte 
}

#origin 32
value1H = 0x2e; value1L = 0xff
	// sample input
value2H = 0x19; value2L = 0x00
add16(&value1H,&value1L,&value2H,&value2L)

// trap execution to be able to look at value2
loop {}
